package org.nisum.controller;

import org.nisum.model.Order;
import org.nisum.service.OrderService;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

@RestController
@RequestMapping("/orders")
public class OrderController {

    private final OrderService orderService;

    public OrderController(OrderService orderService) {
        this.orderService = orderService;
    }

//    @PostMapping("/createOrder")
//    public Mono<Order> createOrder(@RequestBody Order order){
//        return orderService.createOrder(order);
//    }

//    @GetMapping("/{id}")
//    public Mono<Order> getOrderById(@PathVariable String id){
//        return orderService.getOrderById(id);
//    }

    @GetMapping(value = "/getAllOrders", produces = "application/json")
    public Flux<Order> getAllOrders(@RequestParam(name = "page",defaultValue = "0") int page, @RequestParam(name = "size", defaultValue = "10") int size){
        return orderService.getAllOrders(page,size);
    }
//
//        @GetMapping("/getAllOrders")
//    public Flux<Order> getOrders(){
//        return orderService.getOrders();
//    }


}
