package org.nisum.service;

import lombok.var;
import org.nisum.exception.OrderNotFoundException;
import org.nisum.model.Order;
import org.nisum.repository.OrderRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.mongodb.core.ReactiveMongoTemplate;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Service;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.time.LocalDateTime;


@Service
public class OrderService {

    public static final Logger log = LoggerFactory.getLogger(OrderService.class);

    @Autowired
    private OrderRepository orderRepository;
    @Autowired
    private ReactiveMongoTemplate reactiveMongoTemplate;
//    private final KafkaTemplate<String,String> kafkaTemplate;



//    public Mono<Order> createOrder(Order order){
//
//        if(order.getProductId() == null){
//            return Mono.error(new OrderNotFoundException("Order Id cannot be null"));
//        }
//        order.setStatus("Placed");
//        order.setTimeStamp(LocalDateTime.now());
//        return orderRepository.save(order).doOnSuccess(
//                order1 -> kafkaTemplate
//                        .send("order-status-topic",
//                                "Order with product id: " + order1.getProductId()
//                                +" is placed successfully" ));
//
//    }

    public Flux<Order> getAllOrders(int page, int size) {
        Pageable pageable = PageRequest.of(page,size);
        return  orderRepository.findAllBy(pageable);

    }

//    public Flux<Order> getOrders(){
//        return orderRepository.findAll();
//    }
//
//    public Mono<Order> getOrderById(String id) {
//        return orderRepository.findById(id);
//    }
}
